<?php

/*
 * This file is used for controlling the data for the Add / Edit page
 */

include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . '/admin/model/db.php');

$nnrobots_content_fire_db = new NNRobots_Content_Fire_DB();

global $wp_roles;

$post_types = get_post_types(array('public' => true));

// If the user saves a content fire

if ( ( isset($_POST['submit-top']) || isset($_POST['submit-bottom']) || isset($_POST['submit_aweber']) ) && check_admin_referer(self::$prefix . 'admin_settings')) {

	if (empty($_POST[self::$prefix_dash . 'name'])) {
		?>
		<script type="text/javascript">
			window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>";
		</script>
		<?php
	}

	$content_fire = NNRobots_Content_Fire_Admin_Functions::save_data();

	// Redirect User to All Content Fires page after they add a content fire

	if ( ( isset($_POST["submit-top"]) && $_POST["submit-top"] == "Save" ) || ( isset($_POST["submit-bottom"]) && $_POST["submit-bottom"] == 'Save' ) ) {
		$nnrobots_content_fire_db->add_data($content_fire);
		?>
		<script type="text/javascript">
			window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>";
		</script>
		<?php
	}

	// Redirect User to All Content Fires page after they save a content fire

	if ( ( isset($_POST["submit-top"]) && $_POST["submit-top"] == "Update" ) || ( isset($_POST["submit-bottom"]) && $_POST["submit-bottom"] == 'Update' ) ) {
		$content_fire['id'] = $_GET['content_fire_id'];
		$nnrobots_content_fire_db->update_data($content_fire);
		?>
		<script type="text/javascript">
			window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>";
		</script>
		<?php
	}
}

$default_content_fire = NNRobots_Content_Fire_Admin_Functions::default_content_fire();

// Check if updating a record or adding a new one

if (isset($_GET["content_fire_id"])) {
	$edit_data = $nnrobots_content_fire_db->get_data_from_id($_GET["content_fire_id"]);
} else {

	// Create default values from all post types

	$trigger = $default_content_fire['trigger'];

	foreach ($post_types as $post_type) {
		$trigger[$post_type] = array(
			'all'	=>	true,
			'id'	=>	''
		);
	}

	$trigger['type'] = 'site';
	$trigger['category'] = array(
		'all' 	=> true,
		'id' 	=> ''
	);
	$trigger['tag'] = array(
		'id' => ''
	);

	$edit_data = array_merge($default_content_fire, array('trigger' => $trigger));
}

if (isset($edit_data['template']) && !is_array($edit_data['template'])) $edit_data['template'] = (array) NNRobots_Content_Fire_Admin_Functions::mb_unserialize($edit_data['template']);
if (isset($edit_data['style']) && !is_array($edit_data['style'])) $edit_data['style'] = (array) unserialize($edit_data['style']);
if (isset($edit_data['trigger']) && !is_array($edit_data['trigger'])) $edit_data['trigger'] = (array) unserialize($edit_data['trigger']);
if (isset($edit_data['social']) && !is_array($edit_data['social'])) $edit_data['social'] = (array) unserialize($edit_data['social']);
if (isset($edit_data['news_letter']) && !is_array($edit_data['news_letter'])) $edit_data['news_letter'] = (array) unserialize($edit_data['news_letter']);
if (isset($edit_data['args']) && !is_array($edit_data['args'])) $edit_data['args'] = (array) NNRobots_Content_Fire_Admin_Functions::mb_unserialize($edit_data['args']);

// Detect if in A/B Test

$ab_test = false;

if (isset($edit_data['args']['ab_testing']['active']) && $edit_data['args']['ab_testing']['active']) {
	$ab_test = true;
}

// Include the Add Edit php file for all settings

require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . '/admin/views/add-edit.php');

$post_types_array = array();
foreach ($post_types as $post_type) {
	$post_types_array[] = $post_type;
}

wp_localize_script(self::$prefix . 'admin_add_edit_js', 'nnr_cf_data', array(
	'ajaxurl'       => admin_url( 'admin-ajax.php' ),
	'prefix'		=> self::$prefix,
	'prefix_dash' 	=> self::$prefix_dash,
	'post_types'	=> $post_types_array,
));