/**
 *
 * Created by Kyle Benk
 *
 */

jQuery(document).ready(function($) {

	if (typeof(nnr_cf_data) != "undefined" && nnr_cf_data !== null) {

		// Get all content fires

		$('.' + nnr_cf_data.prefix_dash + 'wrap').each(function( index ) {

			var wrap = $(this);

			displayContentFire($(this).attr('data-id'));

			//jQuery
			$(window).on('DOMContentLoaded load resize scroll', function() {
				onVisibilityChange(wrap);
			});

			// Track links being clicked

			$('.' + nnr_cf_data.prefix_dash + 'container-' + $(this).attr('data-id')).click(function(event){

				// Link was clicked

				if ($(event.target).closest('a').length){

					var data = {
						'action': 'nnr_cf_record_click',
						'content_fire_id': $(this).closest('.' + nnr_cf_data.prefix_dash + 'wrap').attr('data-id')
					};
					// We can also pass the url value separately from ajaxurl for front end AJAX implementations
					$.post(nnr_cf_data.ajaxurl, data, function(response) {
						console.log(response);
					});

				}
			});

			// Move to correct placement after X paragraphs

			if (!$(this).hasClass(nnr_cf_data.prefix_dash + 'widget') && $(this).attr('data-placement') == 'paragraphs') {

				var paragraphs = $(this).attr('data-paragraphs');

				if ($(this).attr('data-paragraphs') > $('.entry-content').children('p').length) {
					paragraphs = $('.entry-content').children('p').length;
				}

				$(this).insertAfter(".entry-content > p:nth-of-type(" + paragraphs + ")");
			}

			// Newsletter submission

			$(this).find('.' + nnr_cf_data.prefix_dash + 'newsletter').submit(function(event){

			    $(this).find('.' + nnr_cf_data.prefix_dash + 'submit')
			    	.append('<i style="margin-left: 10px;" class="' + nnr_cf_data.prefix_dash + 'submit-spinner fa fa-spinner fa-spin"></i>');

			    event.preventDefault();

				var data = {
					'action': 'nnr_cf_add_email',
					'content_fire_id': $(this).closest('.' + nnr_cf_data.prefix_dash + 'wrap').attr('data-id'),
					'type': $(this).find('.' + nnr_cf_data.prefix_dash + 'newsletter-type').data('newsletter-type'),
					'email': $(this).find('.' + nnr_cf_data.prefix_dash + 'email').val(),
					'first_name': $(this).find('.' + nnr_cf_data.prefix_dash + 'first-name').val(),
					'last_name': $(this).find('.' + nnr_cf_data.prefix_dash + 'last-name').val(),
				};

				// We can also pass the url value separately from ajaxurl for front end AJAX implementations
				jQuery.post(nnr_cf_data.ajaxurl, data, function(response) {

					response = jQuery.parseJSON(response);
					if (typeof(response.conversion) != 'undefined') {
						console.log(response.conversion);
					}

					if (response.success_action == 'redirect') {

						var win = window.open(response.url, '_self');
						win.focus();

					} else {
						$('.' + nnr_cf_data.prefix_dash + 'wrap-' + response.id)
							.find('.' + nnr_cf_data.prefix_dash + 'message')
							.html('<i class="fa fa-' + response.status + '"></i> ' + response.message)
							.removeClass('hidden');
					}

					$('.' + nnr_cf_data.prefix_dash + 'wrap-' + response.id).find('.' + nnr_cf_data.prefix_dash + 'submit-spinner').remove();

				});

			});
		});

    }

    // Preview

    if (nnr_cf_data.preview) {

	    if ($('.' + nnr_cf_data.prefix_dash + 'wrap').hasClass(nnr_cf_data.prefix_dash + 'widget')) {
			$('.' + nnr_cf_data.prefix_dash + 'wrap').css('max-width', '250px');
	    } else {
		    $('.' + nnr_cf_data.prefix_dash + 'wrap').css('max-width', '700px');
	    }

        $('.' + nnr_cf_data.prefix_dash + 'container').css('border-color', '#000000');

		$('.' + nnr_cf_data.prefix_dash + 'wrap').bPopup({
            modalClose: true,
            opacity: 0.8,
            positionStyle: 'fixed', //'fixed' or 'absolute'
        });

    }

	/**
	 *  Display a Popup
	 *
	 * @access public
	 * @return void
	 */
	function displayContentFire(content_fire_id) {

		addStyling(content_fire_id);

	}

	/**
	 * Add the proper styling to the Popup
	 *
	 * @access public
	 * @return void
	 */
	function addStyling(content_fire_id) {

		// Get relavtive data

		var data = {
			'action': 'nnr_cf_get_styling_data',
			'content_fire_id': content_fire_id
		};

		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(nnr_cf_data.ajaxurl, data, function(response) {

			var styling = jQuery.parseJSON(response);
			var wrap = $('.' + nnr_cf_data.prefix_dash + 'wrap-' + styling.id);

			// Add Google Fonts

			if (styling.heading_google_fonts) {
				addGoogleFont(styling.font_family_heading);
			}

			if (styling.google_fonts) {
				addGoogleFont(styling.font_family);
			}

			// Font Color and Family for Custom HTML template

			wrap.find('.' + nnr_cf_data.prefix_dash + 'container').css('background-color', styling.color);
			wrap.find('.' + nnr_cf_data.prefix_dash + 'container').find('*')
				.not('i')
				.not('.' + nnr_cf_data.prefix_dash + 'icon')
				.not('.' + nnr_cf_data.prefix_dash + 'title')
				.not('.' + nnr_cf_data.prefix_dash + 'close')
				.css('font-family', styling.font_family);

			wrap.find('.' + nnr_cf_data.prefix_dash + 'title').css('font-family', styling.font_family_heading);
			wrap.find('.' + nnr_cf_data.prefix_dash + 'title *').css('font-family', styling.font_family_heading);

	        wrap.find('.' + nnr_cf_data.prefix_dash + 'container').find('p')
	        	.css('font-size', styling.font_size + 'px');
			wrap.find('.' + nnr_cf_data.prefix_dash + 'container').find('p').css('font-weight', styling.font_weight);

			wrap.find('.' + nnr_cf_data.prefix_dash + 'title').css('color', styling.heading_color);

			wrap.find('.' + nnr_cf_data.prefix_dash + 'text').css('color', styling.text_color);
	        wrap.find('.' + nnr_cf_data.prefix_dash + 'list').css('color', styling.text_color);
	        wrap.find('.' + nnr_cf_data.prefix_dash + 'footer').css('color', styling.text_color);
	        wrap.find('.' + nnr_cf_data.prefix_dash + 'message').css('color', styling.text_color);


	        // News letter submit button

	        wrap.find('.' + nnr_cf_data.prefix_dash + 'submit').css('color', styling.nl_color);
	        wrap.find('.' + nnr_cf_data.prefix_dash + 'submit').css('background-color', styling.nl_bg_color);

	        // Yes / No buttons

	        wrap.find('#' + nnr_cf_data.prefix_dash + 'yes').css('color', styling.yes_color);
	        wrap.find('#' + nnr_cf_data.prefix_dash + 'yes').css('background-color', styling.yes_bg_color);
	        wrap.find('#' + nnr_cf_data.prefix_dash + 'no').css('color', styling.no_color);
	        wrap.find('#' + nnr_cf_data.prefix_dash + 'no').css('background-color', styling.no_bg_color);

	        wrap.fadeIn();

	        onVisibilityChange(wrap);

		});

	}

	/**
	 * Adds a google font
	 *
	 * @access public
	 * @return void
	 */
	function addGoogleFont(font) {

		WebFont.load({
			google: {
			  families: [font]
			}
		});

	}

	/**
	 * Check if optin form has been seen
	 *
	 * @access public
	 * @param mixed el
	 * @return void
	 */
	function onVisibilityChange (el) {
        if (!$('.' + nnr_cf_data.prefix_dash + 'wrap-' + el.attr('data-id')).hasClass(nnr_cf_data.prefix_dash + 'wrap-seen') && nnr_isElementInViewport(el)) {
			var data = {
				'action': 'nnr_cf_record_impression',
				'content_fire_id': el.attr('data-id')
			};
			// We can also pass the url value separately from ajaxurl for front end AJAX implementations
			$.post(nnr_cf_data.ajaxurl, data, function(response) {
				console.log(response);
			});

			$('.' + nnr_cf_data.prefix_dash + 'wrap-' + el.attr('data-id')).addClass(nnr_cf_data.prefix_dash + 'wrap-seen');
        }
	}

	/**
	 * Determines if the Content Fire is in the viewport of not
	 *
	 * @access public
	 * @param mixed el
	 * @return void
	 */
	function nnr_isElementInViewport(el) {

		if (el.position().top == 0) {
			return false;
		}

	    return (el.position().top <= ($(window).scrollTop() + $(window).height()));
	}

});

/*================================================================================
 * @name: bPopup - if you can't get it up, use bPopup
 * @author: (c)Bjoern Klinggaard (twitter@bklinggaard)
 * @demo: http://dinbror.dk/bpopup
 * @version: 0.10.0.min
 ================================================================================*/
 (function(b){b.fn.bPopup=function(z,F){function M(){a.contentContainer=b(a.contentContainer||c);switch(a.content){case "iframe":var d=b('<iframe class="b-iframe" '+a.iframeAttr+"></iframe>");d.appendTo(a.contentContainer);r=c.outerHeight(!0);s=c.outerWidth(!0);A();d.attr("src",a.loadUrl);k(a.loadCallback);break;case "image":A();b("<img />").load(function(){k(a.loadCallback);G(b(this))}).attr("src",a.loadUrl).hide().appendTo(a.contentContainer);break;default:A(),b('<div class="b-ajax-wrapper"></div>').load(a.loadUrl,a.loadData,function(c,d,e){k(a.loadCallback,d);G(b(this))}).hide().appendTo(a.contentContainer)}}function A(){a.modal&&b('<div class="b-modal '+e+'"></div>').css({backgroundColor:a.modalColor,position:"fixed",top:0,right:0,bottom:0,left:0,opacity:0,zIndex:a.zIndex+t}).appendTo(a.appendTo).fadeTo(a.speed,a.opacity);D();c.data("bPopup",a).data("id",e).css({left:"slideIn"==a.transition||"slideBack"==a.transition?"slideBack"==a.transition?f.scrollLeft()+u:-1*(v+s):l(!(!a.follow[0]&&m||g)),position:a.positionStyle||"absolute",top:"slideDown"==a.transition||"slideUp"==a.transition?"slideUp"==a.transition?f.scrollTop()+w:x+-1*r:n(!(!a.follow[1]&&p||g)),"z-index":a.zIndex+t+1}).each(function(){a.appending&&b(this).appendTo(a.appendTo)});H(!0)}function q(){a.modal&&b(".b-modal."+c.data("id")).fadeTo(a.speed,0,function(){b(this).remove()});a.scrollBar||b("html").css("overflow","auto");b(".b-modal."+e).unbind("click");f.unbind("keydown."+e);h.unbind("."+e).data("bPopup",0<h.data("bPopup")-1?h.data("bPopup")-1:null);c.undelegate(".bClose, ."+a.closeClass,"click."+e,q).data("bPopup",null);clearTimeout(I);H();return!1}function J(d){w=y.innerHeight||h.height();u=y.innerWidth||h.width();if(B=E())clearTimeout(K),K=setTimeout(function(){D();d=d||a.followSpeed;c.dequeue().each(function(){g?b(this).css({left:v,top:x}):b(this).animate({left:a.follow[0]?l(!0):"auto",top:a.follow[1]?n(!0):"auto"},d,a.followEasing)})},50)}function G(d){var b=d.width(),e=d.height(),f={};a.contentContainer.css({height:e,width:b});e>=c.height()&&(f.height=c.height());b>=c.width()&&(f.width=c.width());r=c.outerHeight(!0);s=c.outerWidth(!0);D();a.contentContainer.css({height:"auto",width:"auto"});f.left=l(!(!a.follow[0]&&m||g));f.top=n(!(!a.follow[1]&&p||g));c.animate(f,250,function(){d.show();B=E()})}function N(){h.data("bPopup",t);c.delegate(".bClose, ."+a.closeClass,"click."+e,q);a.modalClose&&b(".b-modal."+e).css("cursor","pointer").bind("click",q);O||!a.follow[0]&&!a.follow[1]||h.bind("scroll."+e,function(){B&&c.dequeue().animate({left:a.follow[0]?l(!g):"auto",top:a.follow[1]?n(!g):"auto"},a.followSpeed,a.followEasing)}).bind("resize."+e,function(){J()});a.escClose&&f.bind("keydown."+e,function(a){27==a.which&&q()})}function H(d){function b(e){c.css({display:"block",opacity:1}).animate(e,a.speed,a.easing,function(){L(d)})}switch(d?a.transition:a.transitionClose||a.transition){case "slideIn":b({left:d?l(!(!a.follow[0]&&m||g)):f.scrollLeft()-(s||c.outerWidth(!0))-C});break;case "slideBack":b({left:d?l(!(!a.follow[0]&&m||g)):f.scrollLeft()+u+C});break;case "slideDown":b({top:d?n(!(!a.follow[1]&&p||g)):f.scrollTop()-(r||c.outerHeight(!0))-C});break;case "slideUp":b({top:d?n(!(!a.follow[1]&&p||g)):f.scrollTop()+w+C});break;default:c.stop().fadeTo(a.speed,d?1:0,function(){L(d)})}}function L(b){b?(N(),k(F),a.autoClose&&(I=setTimeout(q,a.autoClose))):(c.hide(),k(a.onClose),a.loadUrl&&(a.contentContainer.empty(),c.css({height:"auto",width:"auto"})))}function l(a){return a?v+f.scrollLeft():v}function n(a){return a?x+f.scrollTop():x}function k(a,e){b.isFunction(a)&&a.call(c,e)}function D(){x=p?a.position[1]:Math.max(0,(w-c.outerHeight(!0))/2-a.amsl);v=m?a.position[0]:(u-c.outerWidth(!0))/2;B=E()}function E(){return w>c.outerHeight(!0)&&u>c.outerWidth(!0)}b.isFunction(z)&&(F=z,z=null);var a=b.extend({},b.fn.bPopup.defaults,z);a.scrollBar||b("html").css("overflow","hidden");var c=this,f=b(document),y=window,h=b(y),w=y.innerHeight||h.height(),u=y.innerWidth||h.width(),O=/OS 6(_\d)+/i.test(navigator.userAgent),C=200,t=0,e,B,p,m,g,x,v,r,s,K,I;c.close=function(){q()};c.reposition=function(a){J(a)};return c.each(function(){b(this).data("bPopup")||(k(a.onOpen),t=(h.data("bPopup")||0)+1,e="__b-popup"+t+"__",p="auto"!==a.position[1],m="auto"!==a.position[0],g="fixed"===a.positionStyle,r=c.outerHeight(!0),s=c.outerWidth(!0),a.loadUrl?M():A())})};b.fn.bPopup.defaults={amsl:50,appending:!0,appendTo:"body",autoClose:!1,closeClass:"b-close",content:"ajax",contentContainer:!1,easing:"swing",escClose:!0,follow:[!0,!0],followEasing:"swing",followSpeed:500,iframeAttr:'scrolling="no" frameborder="0"',loadCallback:!1,loadData:!1,loadUrl:!1,modal:!0,modalClose:!0,modalColor:"#000",onClose:!1,onOpen:!1,opacity:.7,position:["auto","auto"],positionStyle:"absolute",scrollBar:!0,speed:250,transition:"fadeIn",transitionClose:!1,zIndex:9997}})(jQuery);